<?php

/**
 * $Revision: $
 * $Author: $
 * $Date: $
 * $Id: $
 * @file      tropaycode.php 
 * @link      http://www.tro.net
 * @copyright (C) tronet GmbH 2014
 * @package   modules
 * @addtogroup models
 * @extend 
 */
class tropaycode extends oxUBase {

    protected $_sThisTemplate = 'tropaycodethankyou.tpl';

    public function log($transactionId = null) {

        require_once( oxregistry::getConfig()->getModulesDir() . 'tronet/tropaycode/library/payment/sofortLibPaycodeDetails.inc.php');
        require_once( oxregistry::getConfig()->getModulesDir() . 'tronet/tropaycode/library/core/sofortLibNotification.inc.php');
        require_once( oxregistry::getConfig()->getModulesDir() . 'tronet/tropaycode/library/core/sofortLibTransactionData.inc.php');

        //$SofortPaycodeDetails = oxNew('SofortLibPaycodeDetails', $configKey);
        $helper = oxNew('trohelper');
        $configKey = $helper->getProperty('sTroPaycodeConfigKey');
        $SofortLibTransactionData = oxNew('SofortLibTransactionData', $configKey);
        $SofortLibTransactionData->addTransaction($transactionId);
        $SofortLibTransactionData->sendRequest();

        $sDate = date('Y-m-d H:i:s');

        $this->setPaymentDateTime($SofortLibTransactionData->getStatus(), $SofortLibTransactionData->getUserVariable(0), $sDate);
        $this->cancelOrder($SofortLibTransactionData->getStatus(), $SofortLibTransactionData->getUserVariable(0));


        $oTroPaycodeLog = oxNew('tropaycodelog');
        $oTroPaycodeLog->tropaycodelog__trooxidorder = new oxField($SofortLibTransactionData->getUserVariable(0));
        $oTroPaycodeLog->tropaycodelog__paycode = new oxField($SofortLibTransactionData->getPaycode());
        $oTroPaycodeLog->tropaycodelog__transaction = new oxField($transactionId);
        $oTroPaycodeLog->tropaycodelog__status = new oxField($SofortLibTransactionData->getStatus());
        $oTroPaycodeLog->tropaycodelog__statusreason = new oxField($SofortLibTransactionData->getStatusReason());
        $oTroPaycodeLog->tropaycodelog__timestamp = new oxField(date('Y-m-d H:i:s'));
        $oTroPaycodeLog->save();


        $oDb = oxDB::getDb();        
        
        
        $sSql = "UPDATE tropaycodelog SET "
                . " statusreason = '" . $SofortLibTransactionData->getStatusReason() . "', "
                . " status = '" . $SofortLibTransactionData->getStatus() . "' "
                . " WHERE TRANSACTION = '" . $oTroPaycodeLog->tropaycodelog__transaction . "' "
                . " AND STATUS = '".$oTroPaycodeLog->tropaycodelog__status . "';";

        $oDb->Execute($sSql);
        $this->render();
    }

    public function updateStatus() {
        
        $helper = oxNew('trohelper');
        $configKey = $helper->getProperty('sTroPaycodeConfigKey');

        $this->render($configKey);
    }

    /**
     * cancels order, if status is loss or refunded 
     *
     * @param string $sStatus 
     * @param string $sTransactionId order ID
     *
     * @return null
     */
    public function cancelOrder($sStatus, $sOxOrderId) {
        
        switch ($sStatus) {
            case 'loss':
            case 'refunded':
                
                $sOrderId = $sOxOrderId;
                $oOrder = oxNew('oxorder');
                if ($oOrder->load($sOrderId)) {
                    $oOrder->oxorder__oxstorno = 1;
                    $oOrder->oxorder__oxpaid = "0000-00-00 00:00:00";
                    $oOrder->cancelOrder();
                    $oOrder->save();
                    }
            break;
        }
    }

    /**
     * sets payment-status for order, if status is received or pending
     *
     * @param string $sStatus 
     * @param string $sTransactionId order ID
     * @param string $sDate 
     *
     * @return null
     */
    public function setPaymentDateTime($sStatus, $sTransactionId, $sDate) {
        switch ($sStatus) {
            case 'received':
            case 'pending':
                $sUpdate = "UPDATE oxorder SET oxpaid='" . $sDate . "', oxstorno = 0 WHERE OXID='" . $sTransactionId . "'";
                $oDB = oxDB::getDB();
                $oDB->Execute($sUpdate);
                
                // set all articles from orderArticles to storno = 0
                $sUpdate2 = "UPDATE oxorderarticles SET oxstorno = 0 WHERE OXORDERID = '" .  $sTransactionId . "'";
                $oDB->Execute($sUpdate2);
                break;
        }
    }

    public function render() {

        parent::render();
        return $this->_sThisTemplate;
    }

    public function notifyStatus() {

        $transactionId = oxRegistry::getConfig()->getRequestParameter('transactionid');
        $this->log($transactionId);
    }

}
